# this will create all necessery stuff for both netacct and netstat
#

#
# Table structure for table `ip_mac`
#
create database if not exists netacct;
use netacct;
grant usage on netacct.* to acct@localhost ;
grant select,update,insert on netacct.* to acct@localhost ;
SET PASSWORD FOR "acct"@"localhost"=PASSWORD("acct_password");


CREATE TABLE ip_mac (
  macid bigint(40) unsigned NOT NULL auto_increment,
  ipid bigint(40) unsigned NOT NULL default '0',
  mac varchar(17) NOT NULL default '',
  current_mac varchar(17) NOT NULL default '',
  status set('static','dynamic') NOT NULL default 'dynamic',
  PRIMARY KEY  (macid),
  KEY ipid (ipid)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `ipallow`
#

CREATE TABLE if not exists ipallow (
  ip_host varchar(255) NOT NULL default '',
  PRIMARY KEY  (ip_host)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `logins`
#

CREATE TABLE if not exists logins (
  uid int(10) unsigned NOT NULL default '0',
  date datetime NOT NULL default '0000-00-00 00:00:00',
  ip char(20) NOT NULL default '',
  PRIMARY KEY  (uid,date)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `rrd`
#

CREATE TABLE if not exists rrd (
  ip varchar(15) NOT NULL default '',
  input int(20) NOT NULL default '0',
  output int(20) NOT NULL default '0',
  peer_input int(20) NOT NULL default '0',
  peer_output int(20) NOT NULL default '0',
  direct_input int(20) NOT NULL default '0',
  direct_output int(20) NOT NULL default '0',
  local_input int(20) NOT NULL default '0',
  local_output int(20) NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `traffic`
#

CREATE TABLE if not exists traffic (
  id int(11) unsigned NOT NULL auto_increment,
  ip varchar(15) NOT NULL default '',
  time datetime NOT NULL default '0000-00-00 00:00:00',
  input int(20) NOT NULL default '0',
  output int(20) NOT NULL default '0',
  peer_input int(20) NOT NULL default '0',
  peer_output int(20) NOT NULL default '0',
  direct_input int(20) NOT NULL default '0',
  direct_output int(20) NOT NULL default '0',
  local_input int(20) NOT NULL default '0',
  local_output int(20) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY ip (ip),
  KEY time (time)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `users`
#

CREATE TABLE if not exists users (
  uid int(10) NOT NULL auto_increment,
  login varchar(15) NOT NULL default '',
  password varchar(35) NOT NULL default '',
  status enum('client','pclient','admin') NOT NULL default 'client',
  name tinytext NOT NULL,
  email varchar(100) NOT NULL default '',
  phone varchar(12) NOT NULL default '0',
  address tinytext NOT NULL,
  language varchar(10) NOT NULL default 'bg',
  input_traffic_price float(5,2) unsigned NOT NULL default '0.00',
  output_traffic_price float(5,2) unsigned NOT NULL default '0.00',
  input_peering_price float(5,2) unsigned NOT NULL default '0.00',
  output_peering_price float(5,2) unsigned NOT NULL default '0.00',
  input_direct_price float(5,2) unsigned NOT NULL default '0.00',
  output_direct_price float(5,2) unsigned NOT NULL default '0.00',
  input_local_price float(5,2) unsigned NOT NULL default '0.00',
  output_local_price float(5,2) unsigned NOT NULL default '0.00',
  traffic_type tinyint(4) unsigned NOT NULL default '0',
  traffic_limit bigint(20) unsigned NOT NULL default '0',
  int_chk tinyint(2) unsigned NOT NULL default '0',
  peer_chk tinyint(2) unsigned NOT NULL default '0',
  direct_chk tinyint(2) unsigned NOT NULL default '0',
  local_chk tinyint(2) unsigned NOT NULL default '0',
  PRIMARY KEY  (uid,login),
  UNIQUE KEY login (login),
  UNIQUE KEY uid (uid)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `users_ip`
#

CREATE TABLE if not exists users_ip (
  ipid bigint(40) NOT NULL auto_increment,
  uid int(10) NOT NULL default '0',
  ip varchar(15) NOT NULL default '',
  PRIMARY KEY  (ipid),
  KEY uid (uid)
) TYPE=MyISAM;

